<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="商品名称" prop="store_name">
                    <el-input v-model="formData.store_name" clearable :readonly="false" disabled />
                </el-form-item>
                <el-form-item label="供货价" prop="purchase">
                    <el-input v-model="formData.purchase" clearable :readonly="false" />
                </el-form-item>
                <el-form-item label="商户价" prop="cost">
                    <el-input v-model="formData.cost" clearable :readonly="false" />
                </el-form-item>
                <el-form-item label="零售价" prop="price">
                    <el-input v-model="formData.price" clearable :readonly="false" />
                </el-form-item>
				
				<el-form-item label="分组价格" prop="price_config">
					<div class="m-1 flex" v-for="item in formData.price_config" :key="item.id">
						<div style="display: inline-block; margin-right: 6px">{{ item.group_name }}:</div>
						<div style="display: inline-block;">
						    <el-input v-model="item.price" style="width: 80px">
							</el-input>
						</div>
					</div>
				</el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="storeProductPriceEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import {
    apiStoreProductPriceAdd,
    apiStoreProductPriceEdit,
    apiStoreProductPriceDetail
} from '@/api/store_product_price'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑商品价格更改' : '新增商品价格更改'
})

// 表单数据
const formData = reactive({
    id: '',
    store_name: '',
    purchase: '',
    cost: '',
    price: '',
	price_config: []
})

// 表单验证
const formRules = reactive<any>({})

// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiStoreProductPriceDetail({
        id: row.id
    })
    setFormData(data)
}

// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData }
    mode.value == 'edit'
        ? await apiStoreProductPriceEdit(data)
        : await apiStoreProductPriceAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
